
<!DOCTYPE html>


<html lang="en" data-content_root="../../" >

  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>Transform graph &#8212; Eclipse Aidge  documentation</title>
  
  
  
  <script data-cfasync="false">
    document.documentElement.dataset.mode = localStorage.getItem("mode") || "";
    document.documentElement.dataset.theme = localStorage.getItem("theme") || "";
  </script>
  <!--
    this give us a css class that will be invisible only if js is disabled
  -->
  <noscript>
    <style>
      .pst-js-only { display: none !important; }

    </style>
  </noscript>
  
  <!-- Loaded before other Sphinx assets -->
  <link href="../../_static/styles/theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />
<link href="../../_static/styles/pydata-sphinx-theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />

    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=8f2a1f02" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css?v=4ae1632d" />
    <link rel="stylesheet" type="text/css" href="../../_static/copybutton.css?v=76b2166b" />
    <link rel="stylesheet" type="text/css" href="../../_static/sg_gallery.css?v=d2d258e8" />
    <link rel="stylesheet" type="text/css" href="../../_static/sphinx-design.min.css?v=95c83b7e" />
    <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=794b2ffd" />
  
  <!-- So that users can add custom icons -->
  <script src="../../_static/scripts/fontawesome.js?digest=8878045cc6db502f8baf"></script>
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf" />
<link rel="preload" as="script" href="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf" />

    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/clipboard.min.js?v=a7894cd8"></script>
    <script src="../../_static/copybutton.js?v=f281be69"></script>
    <script src="../../_static/design-tabs.js?v=f930bc37"></script>
    <script src="https://cdn.jsdelivr.net/npm/@jupyter-widgets/html-manager@^1.0.1/dist/embed-amd.js"></script>
    <script type="module" src="https://cdn.jsdelivr.net/npm/mermaid@10.3.0/dist/mermaid.esm.min.mjs"></script>
    <script type="module" src="https://cdn.jsdelivr.net/npm/@mermaid-js/layout-elk@0.1.4/dist/mermaid-layout-elk.esm.min.mjs"></script>
    <script type="module">import mermaid from "https://cdn.jsdelivr.net/npm/mermaid@10.3.0/dist/mermaid.esm.min.mjs";import elkLayouts from "https://cdn.jsdelivr.net/npm/@mermaid-js/layout-elk@0.1.4/dist/mermaid-layout-elk.esm.min.mjs";mermaid.registerLayoutLoaders(elkLayouts);mermaid.initialize({startOnLoad:false});</script>
    <script src="https://cdn.jsdelivr.net/npm/d3@7.9.0/dist/d3.min.js"></script>
    <script type="module">
import mermaid from "https://cdn.jsdelivr.net/npm/mermaid@10.3.0/dist/mermaid.esm.min.mjs";
window.addEventListener("load", () => mermaid.run());
</script>
    <script>DOCUMENTATION_OPTIONS.pagename = 'source/UserGuide/transformGraph';</script>
    <script>
        DOCUMENTATION_OPTIONS.theme_version = '0.16.1';
        DOCUMENTATION_OPTIONS.theme_switcher_json_url = 'https://eclipse-aidge.readthedocs.io/en/dev/_static/version_switcher.json';
        DOCUMENTATION_OPTIONS.theme_switcher_version_match = '0.5.0';
        DOCUMENTATION_OPTIONS.show_version_warning_banner =
            false;
        </script>
    <script src="../../_static/js/mermaid.min.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Static analysis" href="staticAnalysis.html" />
    <link rel="prev" title="Plateform interoperability" href="interoperability.html" />
  <meta name="viewport" content="width=device-width, initial-scale=1"/>
  <meta name="docsearch:language" content="en"/>
  <meta name="docsearch:version" content="0.5.0" />
  </head>
  
  
  <body data-bs-spy="scroll" data-bs-target=".bd-toc-nav" data-offset="180" data-bs-root-margin="0px 0px -60%" data-default-mode="">

  
  
  <div id="pst-skip-link" class="skip-link d-print-none"><a href="#main-content">Skip to main content</a></div>
  
  <div id="pst-scroll-pixel-helper"></div>
  
  <button type="button" class="btn rounded-pill" id="pst-back-to-top">
    <i class="fa-solid fa-arrow-up"></i>Back to top</button>

  
  <dialog id="pst-search-dialog">
    
<form class="bd-search d-flex align-items-center"
      action="../../search.html"
      method="get">
  <i class="fa-solid fa-magnifying-glass"></i>
  <input type="search"
         class="form-control"
         name="q"
         placeholder="Search the docs ..."
         aria-label="Search the docs ..."
         autocomplete="off"
         autocorrect="off"
         autocapitalize="off"
         spellcheck="false"/>
  <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd>K</kbd></span>
</form>
  </dialog>

  <div class="pst-async-banner-revealer d-none">
  <aside id="bd-header-version-warning" class="d-none d-print-none" aria-label="Version warning"></aside>
</div>

  
    <header class="bd-header navbar navbar-expand-lg bd-navbar d-print-none">
<div class="bd-header__inner bd-page-width">
  <button class="pst-navbar-icon sidebar-toggle primary-toggle" aria-label="Site navigation">
    <span class="fa-solid fa-bars"></span>
  </button>
  
  
  <div class="col-lg-3 navbar-header-items__start">
    
      <div class="navbar-item">

  
    
  

<a class="navbar-brand logo" href="../../index.html">
  
  
  
  
  
    
    
      
    
    
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-light" alt=""/>
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-dark pst-js-only" alt=""/>
  
  
    <p class="title logo__title">Eclipse Aidge</p>
  
</a></div>
    
      <div class="navbar-item">
<div class="version-switcher__container dropdown pst-js-only">
  <button id="pst-version-switcher-button-2"
    type="button"
    class="version-switcher__button btn btn-sm dropdown-toggle"
    data-bs-toggle="dropdown"
    aria-haspopup="listbox"
    aria-controls="pst-version-switcher-list-2"
    aria-label="Version switcher list"
  >
    Choose version  <!-- this text may get changed later by javascript -->
    <span class="caret"></span>
  </button>
  <div id="pst-version-switcher-list-2"
    class="version-switcher__menu dropdown-menu list-group-flush py-0"
    role="listbox" aria-labelledby="pst-version-switcher-button-2">
    <!-- dropdown will be populated by javascript on page load -->
  </div>
</div></div>
    
  </div>
  
  <div class="col-lg-9 navbar-header-items">
    
    <div class="me-auto navbar-header-items__center">
      
        <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
      
    </div>
    
    
    <div class="navbar-header-items__end">
      
        <div class="navbar-item navbar-persistent--container">
          

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
        </div>
      
      
        <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
      
        <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
      
    </div>
    
  </div>
  
  
    <div class="navbar-persistent--mobile">

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
    </div>
  

  
    <button class="pst-navbar-icon sidebar-toggle secondary-toggle" aria-label="On this page">
      <span class="fa-solid fa-outdent"></span>
    </button>
  
</div>

    </header>
  

  <div class="bd-container">
    <div class="bd-container__inner bd-page-width">
      
      
      
      <dialog id="pst-primary-sidebar-modal"></dialog>
      <div id="pst-primary-sidebar" class="bd-sidebar-primary bd-sidebar">
        

  
  <div class="sidebar-header-items sidebar-primary__section">
    
    
      <div class="sidebar-header-items__center">
        
          
          
            <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
          
        
      </div>
    
    
    
      <div class="sidebar-header-items__end">
        
          <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
        
          <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
        
      </div>
    
  </div>
  
    <div class="sidebar-primary-items__start sidebar-primary__section">
        <div class="sidebar-primary-item">
<nav class="bd-docs-nav bd-links"
     aria-label="Section Navigation">
  <p class="bd-links__title" role="heading" aria-level="1">Section Navigation</p>
  <div class="bd-toc-item navbar-nav"><ul class="current nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="architecture.html">Framework architecture</a></li>
<li class="toctree-l1"><a class="reference internal" href="data.html">Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="modelGraph.html">Computational graph</a></li>
<li class="toctree-l1"><a class="reference internal" href="loadStoreModel.html">Load and store model</a></li>
<li class="toctree-l1"><a class="reference internal" href="interoperability.html">Plateform interoperability</a></li>
<li class="toctree-l1 current active"><a class="current reference internal" href="#">Transform graph</a></li>
<li class="toctree-l1"><a class="reference internal" href="staticAnalysis.html">Static analysis</a></li>
<li class="toctree-l1"><a class="reference internal" href="executeGraph.html">Runtime graph execution</a></li>
<li class="toctree-l1"><a class="reference internal" href="learnModel.html">Learn model</a></li>
<li class="toctree-l1"><a class="reference internal" href="benchmark.html">Benchmark neural network model</a></li>
<li class="toctree-l1"><a class="reference internal" href="ensureRobustness.html">Ensure robustness</a></li>
<li class="toctree-l1"><a class="reference internal" href="optimizeGraph.html">Optimize graph</a></li>
<li class="toctree-l1"><a class="reference internal" href="export.html">Perform an export</a></li>
<li class="toctree-l1"><a class="reference internal" href="learnEdge.html">Learn on edge</a></li>
</ul>
</div>
</nav></div>
    </div>
  
  
  <div class="sidebar-primary-items__end sidebar-primary__section">
      <div class="sidebar-primary-item">
<div id="ethical-ad-placement"
      class="flat"
      data-ea-publisher="readthedocs"
      data-ea-type="readthedocs-sidebar"
      data-ea-manual="true">
</div></div>
  </div>


      </div>
      
      <main id="main-content" class="bd-main" role="main">
        
        
          <div class="bd-content">
            <div class="bd-article-container">
              
              <div class="bd-header-article d-print-none">
<div class="header-article-items header-article__inner">
  
    <div class="header-article-items__start">
      
        <div class="header-article-item">

<nav aria-label="Breadcrumb" class="d-print-none">
  <ul class="bd-breadcrumbs">
    
    <li class="breadcrumb-item breadcrumb-home">
      <a href="../../index.html" class="nav-link" aria-label="Home">
        <i class="fa-solid fa-home"></i>
      </a>
    </li>
    
    <li class="breadcrumb-item"><a href="index.html" class="nav-link">User Guide</a></li>
    
    <li class="breadcrumb-item active" aria-current="page"><span class="ellipsis">Transform graph</span></li>
  </ul>
</nav>
</div>
      
    </div>
  
  
</div>
</div>
              
              
              
                
<div id="searchbox"></div>
                <article class="bd-article">
                  
  <section id="transform-graph">
<h1>Transform graph<a class="headerlink" href="#transform-graph" title="Link to this heading">#</a></h1>
<section id="overview">
<h2>Overview<a class="headerlink" href="#overview" title="Link to this heading">#</a></h2>
<p>AIDGE aims to simplify the manipulation of the graphs the users could have. For that purpose, the framework provides several tools to perform graph manipulation and transformation.
This refers to the problematic of graph matching (a.k.a Subgraph isomorphism problem). This problem appears when you want to transform a RAW input graph into a supported one. The RAW input graph is an unaltered one (for example a graph directly imported from ONNX). It might contain <a class="reference internal" href="modelGraph.html#node"><span class="std std-ref">nodes</span></a>, which are not implemented in the framework. Therefore, you need to replace all of the unimplemented nodes (or sub graph) with implemented ones, which are mathematically equivalent. In practice, transforming a graph in AIDGE follows this pipeline :</p>
<pre align="center" class="mermaid align-center">
        flowchart LR

    A(&quot;`**Describe graph patterns**
    Node Regex &amp; Graph Regex`&quot;) --&gt; B(&quot;`**Match patterns**
    Graph Matching`&quot;) --&gt; C(&quot;`**Graph transformation**
    Transformation functions`&quot;)
    </pre><p>The following sections explains each step of the pipeline.</p>
</section>
<section id="describe-graph-patterns">
<h2>Describe graph patterns<a class="headerlink" href="#describe-graph-patterns" title="Link to this heading">#</a></h2>
<p>In order to find specific patterns inside a graph, there is first a need to describe those patterns. AIDGE introduces an innovative way to describe graph patterns, Graph Regular Expression, inspired by regular expression from the formal language theory.
Graph Regular Expression combines two complementary components:</p>
<ul class="simple">
<li><p>Node Regex : Describe the conditions an <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> has to fullfill</p></li>
<li><p>Graph Regex : Describe the graph topological pattern</p></li>
</ul>
<section id="node-regex">
<h3>Node Regex<a class="headerlink" href="#node-regex" title="Link to this heading">#</a></h3>
<p>In the context of graph matching, we need to check whether any <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> corresponds to a subset of operators that we define.
We want to be able to characterize:</p>
<ul>
<li><p>The operator <strong>type</strong></p>
<blockquote>
<div><ul class="simple">
<li><p>Example: Conv</p></li>
</ul>
</div></blockquote>
</li>
<li><p>The <strong>attributes</strong> of the <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a></p>
<blockquote>
<div><ul class="simple">
<li><p>Example: For a convolution, we only want to recognize convolutions with 3x3 kernels.</p></li>
</ul>
</div></blockquote>
</li>
<li><p>One of several operator <strong>types</strong></p>
<blockquote>
<div><ul class="simple">
<li><p>Example: Conv or BatchNorm or FC</p></li>
</ul>
</div></blockquote>
</li>
</ul>
<p>To meet these specifications, we introduce the notion of Node Regex.</p>
<img alt="../../_images/NodeRegexChain.PNG" src="../../_images/NodeRegexChain.PNG" />
<section id="node-regex-lexer">
<h4>Node Regex Lexer<a class="headerlink" href="#node-regex-lexer" title="Link to this heading">#</a></h4>
<p>Tokenize the string taken as an input of the lexer into tokens. A token is a Key and a Lexem ; the lexem is an additional information on the key.</p>
<p>Example of keys:</p>
<div class="pst-scrollable-table-container"><table class="table table-center">
<thead>
<tr class="row-odd"><th class="head"><p>Character</p></th>
<th class="head"><p>Key</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">&amp;&amp;</span></code></p></td>
<td><p>AND</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">||</span></code></p></td>
<td><p>OR</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">!</span></code></p></td>
<td><p>NOT</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">==</span></code></p></td>
<td><p>EQ</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">!=</span></code></p></td>
<td><p>NEQ</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">[A-Za-z][A-Za-z0-9</span> <span class="pre">]*</span></code></p></td>
<td><p>KEY</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">[0..-9]+</span></code></p></td>
<td><p>INTEGER</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">[0-9]+.[0-9]*</span></code></p></td>
<td><p>FLOAT</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">\'[A-Za-z0-9</span> <span class="pre">]+\'</span></code></p></td>
<td><p>STRING</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">True|False</span></code></p></td>
<td><p>BOOL</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">[A-Za-z][A-Za-z0-9</span> <span class="pre">]*\(</span></code></p></td>
<td><p>LAMBDA</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">,</span></code></p></td>
<td><p>ARGSEP</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">$</span></code></p></td>
<td><p>NODE</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">\(</span></code></p></td>
<td><p>LPAREN</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">\)</span></code></p></td>
<td><p>RPAREN</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;&quot;</span></code></p></td>
<td><p>STOP</p></td>
</tr>
</tbody>
</table>
</div>
<p><strong>Example:</strong></p>
<img alt="../../_images/LexerExample.PNG" class="align-center" src="../../_images/LexerExample.PNG" />
<p>In the above figure: <code class="docutils literal notranslate"><span class="pre">LAMBDA(“getType”);</span></code>, <code class="docutils literal notranslate"><span class="pre">LAMBDA</span></code> is a key and <code class="docutils literal notranslate"><span class="pre">“getType”</span></code> is the lexem.</p>
</section>
<section id="node-regex-parser">
<h4>Node Regex Parser<a class="headerlink" href="#node-regex-parser" title="Link to this heading">#</a></h4>
<p>Receive token in the order of the string passed to the lexer. It will put them in an Abstract Syntax Tree (AST) by using grammatical rules.</p>
<p><strong>Example of grammatical rules:</strong></p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">expr</span>   <span class="p">:</span> <span class="n">cmpr</span> <span class="p">((</span><span class="n">AND</span> <span class="o">|</span> <span class="n">OR</span><span class="p">)</span> <span class="n">cmpr</span><span class="p">)</span><span class="o">*</span>
<span class="n">cmpr</span>   <span class="p">:</span> <span class="n">val</span> <span class="p">(</span><span class="n">EQ</span><span class="o">|</span><span class="n">NEQ</span><span class="p">)</span> <span class="n">val</span> <span class="o">|</span> <span class="n">LPAREN</span> <span class="n">expr</span> <span class="n">RPAREN</span>
<span class="n">val</span>    <span class="p">:</span> <span class="p">(</span><span class="n">KEY</span><span class="o">|</span><span class="n">INTEGER</span><span class="o">|</span><span class="n">FOAT</span><span class="o">|</span><span class="n">STRING</span><span class="o">|</span><span class="n">LAMBDA</span><span class="p">)</span>
<span class="k">lambda</span> <span class="p">:</span>  <span class="n">LAMBDA</span> <span class="n">val</span> <span class="p">(</span><span class="n">ARGSEP</span> <span class="n">val</span><span class="p">)</span><span class="o">*</span> <span class="n">RPAREN</span>
</pre></div>
</div>
<p><strong>Example of parser intput and output:</strong></p>
<img alt="../../_images/ParserExample.PNG" class="align-center" src="../../_images/ParserExample.PNG" />
</section>
<section id="node-regex-interpreter">
<h4>Node Regex Interpreter<a class="headerlink" href="#node-regex-interpreter" title="Link to this heading">#</a></h4>
<p>Visit the AST in order to process the desired Boolean function, which return True if the Node match the conditions and else return False.</p>
<img alt="../../_images/InterpreterExample.PNG" class="align-center" src="../../_images/InterpreterExample.PNG" />
</section>
</section>
<section id="graph-regex">
<h3>Graph Regex<a class="headerlink" href="#graph-regex" title="Link to this heading">#</a></h3>
<img alt="../../_images/GraphRegexChain.PNG" src="../../_images/GraphRegexChain.PNG" />
<section id="graph-regex-lexer">
<h4>Graph Regex Lexer<a class="headerlink" href="#graph-regex-lexer" title="Link to this heading">#</a></h4>
<p>Tokenize the string taken as an input into a token. Token, is a Key and a Lexem, the lexem is an additional information on the key.</p>
<div class="pst-scrollable-table-container"><table class="table table-center">
<thead>
<tr class="row-odd"><th class="head"><p>Character</p></th>
<th class="head"><p>Key</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">-&gt;</span></code></p></td>
<td><p>NEXT</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">+</span></code></p></td>
<td><p>QOM</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">*</span></code></p></td>
<td><p>QZM</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">AA#n</span></code></p></td>
<td><p>CKEY</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">AAA</span></code></p></td>
<td><p>KEY</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">;</span></code></p></td>
<td><p>SEP</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">(</span></code></p></td>
<td><p>LPAREN</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">)</span></code></p></td>
<td><p>RPAREN</p></td>
</tr>
</tbody>
</table>
</div>
</section>
<section id="graph-regex-parser">
<h4>Graph Regex Parser<a class="headerlink" href="#graph-regex-parser" title="Link to this heading">#</a></h4>
<p>Receive token in the order of the string passed to the lexer. It will put them in an Abstract Syntax Tree (AST) by using grammatical rules.</p>
<p><strong>Example of grammatical rules:</strong></p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>allExpr : domain (SEP domain)*
domain : (exp)(QOM | QZM)? (NEXT exp)*| exp (NEXT exp)*
exp : KEY(QOM | QZM)? |  KEY (NEXT domain)* | CKEY (NEXT domain)*
</pre></div>
</div>
</section>
</section>
<section id="graph-matching">
<h3>Graph Matching<a class="headerlink" href="#graph-matching" title="Link to this heading">#</a></h3>
<img alt="../../_images/GraphMatchingChain.PNG" src="../../_images/GraphMatchingChain.PNG" />
<section id="state-machine">
<h4>State machine<a class="headerlink" href="#state-machine" title="Link to this heading">#</a></h4>
<p>A state machine takes as an input a starting <a class="reference internal" href="modelGraph.html#node"><span class="std std-ref">node</span></a> and an AST and outputs zero or multiple solutions. To find every possible solutions, Aidge uses multiple state machines, each one beginning with a different starting <a class="reference internal" href="modelGraph.html#node"><span class="std std-ref">node</span></a>.
The graph regex produces a state machine and the transition between each state of the machine is conditioned by the Boolean function produced by Node Regex.</p>
</section>
<section id="match-solver">
<h4>Match solver<a class="headerlink" href="#match-solver" title="Link to this heading">#</a></h4>
<p>Receive a set of every solution found by the different state machines. The heuristic used to filter the solutions is to find a set of solutions, which maximise the graph covering with no intersection.</p>
</section>
</section>
</section>
<section id="graph-transformation">
<h2>Graph transformation<a class="headerlink" href="#graph-transformation" title="Link to this heading">#</a></h2>
<section id="metanode">
<h3>MetaNode<a class="headerlink" href="#metanode" title="Link to this heading">#</a></h3>
<p>A MetaNode is equivalent to a <a class="reference internal" href="modelGraph.html#graph-view"><span class="std std-ref">graph view</span></a> as it is a collection of <a class="reference internal" href="modelGraph.html#node"><span class="std std-ref">nodes</span></a>, the difference being that it is opaque to Graph Matching. This means that <a class="reference internal" href="modelGraph.html#node"><span class="std std-ref">nodes</span></a> and <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">Operator</span></a> inside a MetaNode are not seen by the Graph Matching which only see a single <a class="reference internal" href="modelGraph.html#node"><span class="std std-ref">node</span></a>, the MetaNode. A MetaNode uses the implementation of each <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> which it contains or of complex <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> due to the targeted architecture.
Different usage emerged:</p>
<ul class="simple">
<li><p>To create a sub-graph of <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">Operators</span></a> that can be used N times</p></li>
<li><p>During the graph optimization recipe to encapsulate already matched <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operators</span></a>. If a complex operator (group of several operators) does not exist during the pattern matching step, then this part of the graph must be protected. The developer must encapsulate the group of <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> corresponding to the complex operator to avoid the pattern matching function to fuse one <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> of this group with previous <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> (if <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> at the beginning of the sub-graph) or with the next <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> (if at the end).</p></li>
</ul>
<img alt="../../_images/MetaNodeExample.PNG" src="../../_images/MetaNodeExample.PNG" />
<p>MetaNode are <strong>NOT</strong> manipulatedby users but by developpers of the paltform.</p>
<p><strong>What happens when matching a MetaNode with Node instances referenced by a Graph View previously declared ?</strong></p>
<img alt="../../_images/MNGRIntersection.PNG" src="../../_images/MNGRIntersection.PNG" />
<ul class="simple">
<li><p><strong>Case 1:</strong> The <a class="reference internal" href="modelGraph.html#graph-view"><span class="std std-ref">graph view</span></a> becomes empty</p></li>
<li><p><strong>Case 2:</strong> The MetaNode becomes part of the <a class="reference internal" href="modelGraph.html#graph-view"><span class="std std-ref">graph view</span></a></p></li>
<li><p><strong>Case 3:</strong> the <a class="reference internal" href="modelGraph.html#graph-view"><span class="std std-ref">graph view</span></a> only contains OP1</p></li>
</ul>
</section>
<section id="transformation-functions">
<h3>Transformation functions<a class="headerlink" href="#transformation-functions" title="Link to this heading">#</a></h3>
<section id="remove-operator">
<h4>Remove operator<a class="headerlink" href="#remove-operator" title="Link to this heading">#</a></h4>
<p>An ONNX file can be built automatically using an engine. Operations may be added in unnecessary ways; for example, successive transposition of data corresponding to the identity. The pattern matching detects and remove these operations.</p>
</section>
<section id="replace-operator">
<h4>Replace operator<a class="headerlink" href="#replace-operator" title="Link to this heading">#</a></h4>
<p>Recognition of a previously defined pattern enables it to be replaced in the graph by a complex operator, which may be defined by a MetaNode. This new <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> is implemented in an operator plugin added to the platform, and can then be integrated into a <a class="reference internal" href="modelGraph.html#node"><span class="std std-ref">node</span></a>.</p>
</section>
<section id="expand-operator">
<h4>Expand operator<a class="headerlink" href="#expand-operator" title="Link to this heading">#</a></h4>
<p>This involves splitting an <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a> into two <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operators</span></a>. For the sake of clarity, we can imagine that a convolution cannot be performed on a resource all at once, for memory or other reasons. In this case, the convolution is performed in two steps. This will be reflected in the graph by the appearance of 2 <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operators</span></a>.</p>
</section>
</section>
</section>
</section>


                </article>
              
              
              
              
              
                <footer class="prev-next-footer d-print-none">
                  
<div class="prev-next-area">
    <a class="left-prev"
       href="interoperability.html"
       title="previous page">
      <i class="fa-solid fa-angle-left"></i>
      <div class="prev-next-info">
        <p class="prev-next-subtitle">previous</p>
        <p class="prev-next-title">Plateform interoperability</p>
      </div>
    </a>
    <a class="right-next"
       href="staticAnalysis.html"
       title="next page">
      <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">Static analysis</p>
      </div>
      <i class="fa-solid fa-angle-right"></i>
    </a>
</div>
                </footer>
              
            </div>
            
            
              
                <dialog id="pst-secondary-sidebar-modal"></dialog>
                <div id="pst-secondary-sidebar" class="bd-sidebar-secondary bd-toc"><div class="sidebar-secondary-items sidebar-secondary__inner">


  <div class="sidebar-secondary-item">
<div
    id="pst-page-navigation-heading-2"
    class="page-toc tocsection onthispage">
    <i class="fa-solid fa-list"></i> On this page
  </div>
  <nav class="bd-toc-nav page-toc" aria-labelledby="pst-page-navigation-heading-2">
    <ul class="visible nav section-nav flex-column">
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#overview">Overview</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#describe-graph-patterns">Describe graph patterns</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#node-regex">Node Regex</a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#node-regex-lexer">Node Regex Lexer</a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#node-regex-parser">Node Regex Parser</a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#node-regex-interpreter">Node Regex Interpreter</a></li>
</ul>
</li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#graph-regex">Graph Regex</a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#graph-regex-lexer">Graph Regex Lexer</a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#graph-regex-parser">Graph Regex Parser</a></li>
</ul>
</li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#graph-matching">Graph Matching</a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#state-machine">State machine</a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#match-solver">Match solver</a></li>
</ul>
</li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#graph-transformation">Graph transformation</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#metanode">MetaNode</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#transformation-functions">Transformation functions</a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#remove-operator">Remove operator</a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#replace-operator">Replace operator</a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#expand-operator">Expand operator</a></li>
</ul>
</li>
</ul>
</li>
</ul>
  </nav></div>

  <div class="sidebar-secondary-item">

  
  <div class="tocsection editthispage">
    <a href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/edit/master/docs/source/UserGuide/transformGraph.rst">
      <i class="fa-solid fa-pencil"></i>
      
      
        
          Edit on GitLab
        
      
    </a>
  </div>
</div>

  <div class="sidebar-secondary-item">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../../_sources/source/UserGuide/transformGraph.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div></div>

</div></div>
              
            
          </div>
          <footer class="bd-footer-content">
            
          </footer>
        
      </main>
    </div>
  </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script defer src="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf"></script>
<script defer src="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf"></script>

  <footer class="bd-footer">
<div class="bd-footer__inner bd-page-width">
  
    <div class="footer-items__start">
      
        <div class="footer-item">

  <p class="copyright">
    
      © Copyright 2023, CEA LIST.
      <br/>
    
  </p>
</div>
      
        <div class="footer-item">

  <p class="sphinx-version">
    Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 8.1.3.
    <br/>
  </p>
</div>
      
    </div>
  
  
  
    <div class="footer-items__end">
      
        <div class="footer-item">
<p class="theme-version">
  <!-- # L10n: Setting the PST URL as an argument as this does not need to be localized -->
  Built with the <a href="https://pydata-sphinx-theme.readthedocs.io/en/stable/index.html">PyData Sphinx Theme</a> 0.16.1.
</p></div>
      
    </div>
  
</div>

  </footer>
  </body>
</html>